<template>
  <!-- TODO: add user data policy warning about youtube before creating the iframe -->
  <div class="yt-player">
    <!-- Main player -->
    <div v-show="!isHidden">
      <div v-show="playing || currentTimeSync && currentTimeSync >= startSecond + 0.1">
        <div ref="yt-player" style="position: relative" />
      </div>
      <img
        v-show="!playing && (currentTimeSync && currentTimeSync < startSecond + 0.1)"
        alt="youtube thumbnail"
        :style="
          `position: relative;
          object-fit: cover;
          width: ${isLarge ? '711px': '334px'};
          height: ${isLarge ? '400px': '188px'}`
        "
        :src="`https://img.youtube.com/vi/${audio.youtubeId}/0.jpg`"
        @keydown.space="playing = !playing"
        @click="playing = !playing"
      >
    </div>
    <!-- Player for hidden video -->
    <!-- Resize buttom -->
    <v-tooltip left>
      <template #activator="{on, attrs}">
        <v-btn
          v-show="!isHidden"
          v-bind="attrs"
          large
          tile :color="$store.state.primaryColor"
          class="resize-btn rounded-br-xl"
          v-on="on"
          @click="toggleSize"
        >
          <v-icon v-text="isLarge ? 'mdi-move-resize-variant' : 'mdi-flip-h mdi-resize'" />
        </v-btn>
      </template>
      {{ $t(isLarge ? 'youtube-player.resize-down' : 'youtube-player.resize-up') }}
    </v-tooltip>
    <!-- Hide buttom -->
    <v-tooltip left>
      <template #activator="{on, attrs}">
        <v-btn
          v-bind="attrs"
          large
          tile :color="$store.state.primaryColor"
          class="hide-btn rounded-tl-xl"
          v-on="on"
          @click="toggleHide"
        >
          <v-icon v-text="isHidden ? 'mdi-youtube' : 'mdi-eye-off-outline'" />
        </v-btn>
      </template>
      {{ $t(isHidden ? 'youtube-player.show' : 'youtube-player.hide') }}
    </v-tooltip>
  </div>
</template>

<script lang="ts">
import {
  Vue, Component, Prop, PropSync, VModel, Watch, Ref,
} from 'vue-property-decorator';
import YoutubePlayerAPI from 'youtube-player';
import PlayerStates from 'youtube-player/dist/constants/PlayerStates';
import type { Options, YouTubePlayer } from 'youtube-player/dist/types';
import type { Audio, Onset, Second } from '@/data';
import type IPlayer from './IPlayer';

const ASPECT_RATIO = 16 / 9;
const SMALL_HEIGHT = 188; // See .yt-player
const SMALL_WIDTH = SMALL_HEIGHT * ASPECT_RATIO;
const LARGE_HEIGHT = 400;
const LARGE_WIDTH = LARGE_HEIGHT * ASPECT_RATIO;

@Component
export default class YoutubePlayer extends Vue implements IPlayer {
  @Prop({ required: true })
  audio!: Audio;

  @PropSync('lastOnset', { required: true, default: 0 })
  lastOnsetBeforeSwitch!: Onset;

  @Ref('yt-player')
  player!: HTMLElement;

  youtube!: YouTubePlayer;

  isLarge = false;

  isHidden = false;

  // Timestamp

  // This sync props are only used for output ('update:time)
  // The only way to set it is with setTime, or setting it to null
  // Constantly changing values such as scroll or timestamps should only
  // be changed in one direction using reactivity.
  // For two-way binding, one direction must use explicitely called functions
  @PropSync('currentTime', { default: null })
  currentTimeSync!: Second | null;

  @Prop({ required: false, default: 0, type: Number })
  startSecond!: number;

  private isSwitchingId = false;

  @Watch('audio.youtubeId')
  async youtubeIdUpdated() {
    if (this.audio.youtubeId) {
      this.isSwitchingId = true;

      await this.youtube.loadVideoById(
        this.audio.youtubeId,
        this.audio.secondUnit.fromOnset(this.lastOnsetBeforeSwitch as Onset).value,
      );
    }
  }

  mounted() {
    // Create an embedded youtube player
    this.initYoutubePlayer();
  }

  initYoutubePlayer() {
    this.youtube = YoutubePlayerAPI(this.player, {
      // The size of the player
      height: SMALL_HEIGHT,
      width: SMALL_WIDTH,
      // The youtube video id
      videoId: this.audio.youtubeId,
      // minimize user interaction on the youtube player with sensible options
      playerVars: {
        // disablekb: 1, // remove keyboard control
        loop: 0, // do not loop the video (default)
        start: 0, // try to force youtube to play from the start
        // youtube may try to restore progress, dezrann must let it
        controls: 0, // hide the controls
        origin: window.location.host, // should avoid some yt requests failing
        fs: 0, // disable fullscreen
        modestbranding: 1, // try to hide the YT logo, does not work with controls=0
        rel: 0, // only show recommended videos from the same channel
        // It is impossible to disable recommended videos
      },
      // Ask youtube to not store cookies until interacted with
      // Not documented in @types/youtube-player
      host: 'https://www.youtube-nocookie.com',
    } as Options);
    this.youtube.setPlaybackQuality('small');
    // Error callback, handled by player container
    this.youtube.on('error', this.emitError);
    this.youtube.on('stateChange', this.updatePlaying);
    this.youtube.on('ready', () => {
      if (this.$store.state.allowedToPlay || this.currentTimeSync) {
        if (this.playing) {
          this.playing = !true;
          this.youtube.playVideo();
        } else {
          this.youtube.seekTo(this.currentTimeSync || 0, true);
          this.youtube.pauseVideo();
        }
      } else {
        this.youtube.stopVideo();
      }
    });
    this.startAnimation(0 as Second);
  }

  toggleSize() {
    if (this.isLarge) this.youtube.setSize(SMALL_WIDTH, SMALL_HEIGHT);
    else this.youtube.setSize(LARGE_WIDTH, LARGE_HEIGHT);

    this.isLarge = !this.isLarge;
  }

  toggleHide() {
    this.isHidden = !this.isHidden;
  }

  // Add additional update:time events, faster than the dom provides
  startAnimation(lastTime: Second) {
    requestAnimationFrame(async () => {
      let lastTimeBeforeSwitchSeconds = -1;
      if (this.lastOnsetBeforeSwitch !== -1) {
        lastTimeBeforeSwitchSeconds = this.audio.secondUnit
          .fromOnset(this.lastOnsetBeforeSwitch as Onset).value;
      }

      const newTime = await this.youtube.getCurrentTime() as Second;
      if (newTime !== lastTime && !this.isSwitchingId && newTime !== undefined) {
        if (newTime < lastTimeBeforeSwitchSeconds && lastTimeBeforeSwitchSeconds !== -1) {
          this.youtube.seekTo(lastTimeBeforeSwitchSeconds, true);
          this.currentTimeSync = lastTimeBeforeSwitchSeconds as Second;
          this.lastOnsetBeforeSwitch = -1 as Onset;
        } else {
          this.currentTimeSync = newTime;
        }
        this.startAnimation(newTime);
      } else if (this.isSwitchingId) {
        this.startAnimation(this.currentTimeSync || 0 as Second);
      } else {
        this.startAnimation(newTime);
      }
    });
  }

  public setCurrentTime(second: Second) {
    this.youtube.seekTo(second, true);

    if (!this.playing) {
      // If track is paused, manually send update that currentTime has changed
      this.currentTimeSync = second;
      // Fixes youtube starting to play on paused seek
      this.youtube.pauseVideo();
    }
  }

  public reset() {
    this.youtube.stopVideo();
  }

  // Play state

  @VModel({ default: false })
  playing!: boolean;

  async isTrackPlaying(): Promise<boolean> {
    const state = await this.youtube.getPlayerState();

    // Return true if playing or buffering
    return state === PlayerStates.PLAYING || state === PlayerStates.BUFFERING;
  }

  // Upward updates: if playing prop changes, check if player needs to be paused/played
  @Watch('playing')
  async onPlayChanged() {
    const realIsPlaying = await this.isTrackPlaying();
    // If current play status different from current prop playing, play or pause video
    if (!realIsPlaying && this.playing) await this.youtube.playVideo();
    else if (realIsPlaying && !this.playing) await this.youtube.pauseVideo();
  }

  // Upward updates: if time changes to null, reset the player
  // Avoids any problem with forgetting to call reset
  @Watch('time')
  async onTimeChanged() {
    if (this.currentTimeSync === null) this.reset();
  }

  // Send state of the youtube player to parent
  async updatePlaying({ data }: { data: PlayerStates}) {
    if (this.isSwitchingId && data === PlayerStates.PLAYING) {
      this.isSwitchingId = false;
    }

    const realIsPlaying = await this.isTrackPlaying();

    if (this.playing !== realIsPlaying) this.playing = realIsPlaying;

    if (data === PlayerStates.ENDED) {
      this.$emit('ended');
      if (localStorage.getItem('continuePlaying') === 'true') this.$emit('go-to-next');
    }
  }

  emitError(e: CustomEvent<Error>): void {
    this.$emit('error', e);
  }
}
</script>
<style scoped lang="scss">
.yt-player {
  position: relative;
  line-height: 0;// Remove the whitespace under the player
  // min-height: 100%;// Force the 'show' button down
  display: flex;
  // align-self: stretch;
  min-height: 188px; // see SMALL_HEIGHT
  user-select: none;
}
.resize-btn {
  position: absolute;
  top: 0;
  left: 0;
}
.hide-btn {
  position: absolute;
  bottom: 0;
  right: 0;
}
</style>
